//**********************************************************************************
//                                                                                  
//        _   _       _        ___  ___      _        ___  ___          _             
//       | | | |     | |       |  \/  |     | |       |  \/  |         | |            
//       | |_| | ___ | |_   _  | .  . | ___ | |_   _  | .  . | ___   __| |___       
//       |  _  |/ _ \| | | | | | |\/| |/ _ \| | | | | | |\/| |/ _ \ / _` / __|      
//       | | | | (_) | | |_| | | |  | | (_) | | |_| | | |  | | (_) | (_| \__ \      
//       \_| |_/\___/|_|\__, | \_|  |_/\___/|_|\__, | \_|  |_/\___/ \__,_|___/      
//                       __/ |                  __/ |                               
//                      |___/                  |___/                                
//                                                                                  
//                       Website: http://www.holymolymods.com                       
//*********************************************************************************
//Initial code by Extreme Mod
// V.1.0

#include openwarfare\_utils;
#include openwarfare\_eventmanager;

init()
{


	// Get the main module's dvars
	level.scr_parachutes = getdvarx( "scr_parachutes", "int", 0, 0, 3 );

        // Random Enable\Disable
	if ( level.scr_parachutes == 3 ) {
                level.scr_parachutes = randomIntRange( 0, 2 );
	}

	// If Parachutes are disabled then there's nothing else to do here
	if ( level.scr_parachutes == 0 )
		return;

	level.scr_parachutes_only_attackers = getdvarx( "scr_parachutes_only_attackers", "int", 0, 0, 1 );
	level.scr_parachutes_limit_altitude = getdvarx( "scr_parachutes_limit_altitude", "int", 2000, 0, 6000 );


        precacheShader( "shield" );
        precacheModel( "shaneys_chute_i" );

	level thread addNewEvent( "onPlayerConnected", ::onPlayerConnected );
}

onPlayerConnected()
{
	self thread addNewEvent( "onPlayerSpawned", ::onPlayerSpawned );
        self thread onPlayerDisconnect();
}

onPlayerSpawned()
{
        self thread playerParachute();
	self thread addNewEvent( "onPlayerKilled", ::onPlayerKilled );
}

onPlayerKilled()
{
        self endon( "spawned_player" );

        if( isDefined( self.freezehud ) ) { 
               self.freezehud destroy();
        }

        if( isDefined( self.para_shield_icon ) ) { 
               self.para_shield_icon destroy();
        }

        wait( 5.0 );

        if( isDefined( self.isParachuting ) && self.isParachuting == true ) {

                if( isDefined( self.body ) ) {
		        self.body maps\mp\gametypes\_weapons::waitTillNotMoving();
                        self.body delete();
                }

                if( isDefined( self.anchor ) ) {
                        delete_model( self.anchor );
                }

                if( isDefined( self.parachute ) ) {
                        delete_model( self.parachute );
                }

                self.isparachuting = false;
        }

}

onPlayerDisconnect()
{
	
	self waittill( "disconnect" );

        wait( 5.0 );
	
        if( isDefined( self.anchor ) ) {
                delete_model( self.anchor );
        }

        if( isDefined( self.parachute ) ) {
                delete_model( self.parachute );
        }
}

playerParachute()
{
	level endon("game_ended");
	self endon("disconnect");
	self endon("death");

	// Clean up in case of Death
        if( isDefined( self.anchor ) ) {
                delete_model( self.anchor );
        }

        if(isDefined( self.parachute ) ) {
                delete_model( self.parachute );
        }
        
	// If player has already parachuted and parachutes is set to parachute only once per map/round
	if( isDefined( self.pers["haveparachuted"] ) )
		return;

	// If parachutes is set for attackers only then check for attacker self team
	if( level.scr_parachutes_only_attackers == 1 && game["attackers"] != self.pers["team"] )
		return;

	// Starting point for player
	ix = self.origin[0] - 150 + randomint( 800 );
	iy = self.origin[1] - 150 + randomint( 800 );

	// Calculate starting altitude
        iz = 6000 - randomint( 100 );

	// Endpoint for player 
	endpoint = self.origin + ( 0, 0, 24 );

	// Check how high the path is clear
	trace = bulletTrace( endpoint, ( endpoint + ( 0, 0, iz ) ), false, undefined );
	pos = trace["position"];
	iz = pos[2];

	// Limit the altitude
	if( level.scr_parachutes_limit_altitude > 0 )
	{
		if( ( iz - endpoint[2] ) > level.scr_parachutes_limit_altitude )
			iz = endpoint[2] + level.scr_parachutes_limit_altitude - randomint( 100 );
	}

	// Starting point ready
	startpoint = ( ix, iy, iz );

	// Calculate distance between start and end
	distance = distance( startpoint, endpoint );

	// Don't parachute distances below 1000 units (5 seconds)
	if( distance < 1000 ) {
                wait( 0.05 );
	        return;
        }

         // Check if in a building
        isClear = sightTracePassed( endpoint, startpoint, false, undefined );

        // Return if trace failed
        if( isClear == false )
                return;

	// Now we are clear to parachute 
	self.isparachuting = true;
        self.isparachuteProtected = true;

	if( level.scr_parachutes == 1 )
		self.pers["haveparachuted"] = true;
     
	//create a model to attach everything to
	self.parachute = spawn ( "script_model", ( 0, 0, 0 ) );
	self.parachute.origin = self.origin;
	self.parachute.angles = self.angles + ( 0, 0, 0 );

	// Link player to self.anchor
	self.anchor = spawn("script_model", ( 0, 0, 0 ) );
	self.anchor setModel( "shaneys_chute_i" );
	self.anchor.origin = self.parachute.origin;
	self.anchor.angles = self.angles + ( 0, 0, 0 );
	self.parachute linkto( self.anchor );
	self linkto( self.anchor );
	falltime = distance/100 + randomint( 6 );
	self.anchor.origin = startpoint;
	self.anchor moveto( endpoint, falltime );
	
	self playLocalSound( "para_wind" );

	if( !isDefined( self.para_shield_icon ) ) {
	        self.para_shield_icon = newClientHudElem( self );
	        self.para_shield_icon.x = 0;
	        self.para_shield_icon.y = 142;
	        self.para_shield_icon.alignX = "center";
	        self.para_shield_icon.alignY = "middle";
	        self.para_shield_icon.horzAlign = "center_safearea";
	        self.para_shield_icon.vertAlign = "center_safearea";
	        self.para_shield_icon.alpha = 0.9;
	        self.para_shield_icon setShader( "shield", 32, 32);
        }

	if( !isDefined( self.freezehud ) )
	{
	        self.freezehud = newClientHudElem( self );
		self.freezehud.x = 320;
		self.freezehud.y = 180;
		self.freezehud.alignx = "center";
		self.freezehud.aligny = "middle";
		self.freezehud.alpha =0.8;
		self.freezehud.fontScale = 2.2;
	}

	while( isPlayer( self ) && isAlive( self ) && self.anchor.origin[2] > endpoint[2] )
	{
		self.anchor.angles = self.angles;
/*
                // Freeze Controls if attacking
                if ( self attackButtonPressed() || self fragButtonPressed() || self secondaryOffhandButtonPressed() || self playerADS() == 1 ) {
                       self freezeControls( true );
                       self.freezehud.label = &"^3Your Controls are ^4FROZEN!";
                }
*/
               // Paracute Protected unless trying to attack
               if( isDefined( self.isparachuteProtected ) && self.isparachuteProtected == true ) {
                       if ( self attackButtonPressed() || self fragButtonPressed() || self secondaryOffhandButtonPressed() || self meleeButtonPressed() ) {
                               self.isparachuteProtected = false;
                               self.freezehud.label = &"^3Parachute Protection ^1DISABLED!";
                               self.para_shield_icon.alpha = 0;
                       }
                }

		wait( 0.05 );
	}

        if( isDefined( self.freezehud ) ) { 
               self.freezehud destroy();
        }

        if( isDefined( self.para_shield_icon ) ) { 
               self.para_shield_icon destroy();
        }

        self freezeControls( false );
	self unlink();
	self playlocalSound( "para_land" );
	earthquake( 0.4, 1.2, self.origin, 70 );

        self.isparachuting = false;
        self.isparachuteProtected = false;

	self.anchor rotatepitch( 85, 10, 9, 1 );
	self.anchor moveto( endpoint - ( 0, 400, 400 ), 7, 6, 1 );

        wait( 7.0 );
        delete_model( self.anchor );
        delete_model( self.parachute );

}

delete_model( ent )
{

	if( isDefined( ent ) ) {
		ent delete();
        }
}
